Page MenuHomePhabricator

[PowerPC] Remove support for VRSAVE save/restore/update.
ClosedPublic

Authored by sfertile on Feb 24 2020, 8:46 AM.

Details

Summary

After removal of Darwin as a PowerPC subtarget, the VRSAVE save/restore/spill/update code is dead, so remove it while keeping support for vrsave and related instruction aliases for inline asm. I've pre-commited tests to document the existing vrsave handling in relation to @llvm.eh.unwind.init and inline asm usage to show this patch doesn't change the exiting behavior.

Diff Detail

Event Timeline

sfertile created this revision.Feb 24 2020, 8:46 AM
Herald added a project: Restricted Project. · View Herald TranscriptFeb 24 2020, 8:46 AM
MaskRay accepted this revision.Feb 24 2020, 3:14 PM
This revision is now accepted and ready to land.Feb 24 2020, 3:14 PM
sfertile updated this revision to Diff 288981.Aug 31 2020, 10:26 AM

Previous patch was not really NFC, since we were inserting VRSAVE pseudos on AIX, then emiting a fatal error in frame lowering. This was because we missed changing the condition gating the vrsave insertion to include the AIX abi.

I've landed a patch which shows the previous error related to VRSAVE, and the new error I've added in LowerReturn to replace it. The new behavior is more lenient in that we can use vector instructions inside a functions body, and will now only error if we try to pass or return vector types.

sfertile retitled this revision from [PowerPC][NFC] Remove support for VRSAVE save/restore/update. to [PowerPC] Remove support for VRSAVE save/restore/update..Sep 29 2020, 1:26 PM
ZarkoCA accepted this revision.Sep 29 2020, 1:27 PM

LGTM.

nemanjai accepted this revision.Oct 7 2020, 5:43 AM

LGTM. Nice to have this cleaned up. Thanks.